#!/usr/bin/python
from xen.util import vusb_util

def xm_usb_list_assignable_devices():

    usb_devs = vusb_util.get_usb_devices()
    buses = vusb_util.get_assigned_buses()

    for x in buses:
        try:
            usb_devs.remove(x)
        except ValueError:
            pass

    for dev in usb_devs:
        idvendor = vusb_util.get_usb_idvendor(dev)
        idproduct = vusb_util.get_usb_idproduct(dev)
        prodinfo = vusb_util.get_usbdevice_info(dev)
        print "%-13s: ID %-4s:%-4s %s" \
                % (dev, idvendor, idproduct, prodinfo)

xm_usb_list_assignable_devices()
